#ifndef __RTNODE
#define __RTNODE
//------------------------------------------------------------
#include "../func/gendef.h"
//------------------------------------------------------------
class SortedLinList;
class Entry;
class RTree;
//------------------------------------------------------------
class RTNode
{
public:
	bool dirty;                         // TRUE, if node has to be written
	char level;                         // level of the node in the tree (0 means leaf)
    int block;                          // disc block
	int capacity;                       // max. # of entries
	int dimension;
	int num_entries;                    // # of used entries
	Entry *entries;                     // array of entries
	RTree *my_tree;                     // pointer to R-tree

	//--===functions===--
	RTNode(RTree *rt);
    RTNode(RTree *rt, int _block);
    virtual ~RTNode();

	int choose_subtree(float *brm);     // chooses best subtree for insertion
	void enter(Entry *de);              // inserts new entry
	bool FindLeaf(Entry *e);
	float *get_mbr();                   // returns mbr enclosing whole page
    int get_num_of_data();              // returns number of data entries
	R_OVERFLOW insert(Entry *d, RTNode **sn);
                                        // inserts d recursively, if there
                                        // occurs a split, FALSE will be
                                        // returned and in sn a
                                        // pointer to the new node
	bool is_data_node() { return (level==0) ? TRUE : FALSE ;};
	void print();                       // prints rectangles
	void rangeQuery(float *mbr, SortedLinList *res);
	void read_from_buffer(char *buffer);// reads data from buffer
	void split(RTNode *sn);             // splits directory page to *this and sn
	int split(float **mbr, int **distribution);
                                        // splits an Array of mbr's into 2
                                        // and returns in distribution
                                        // which *m mbr's are to be
                                        // moved

    void write_to_buffer(char *buffer); // writes data to buffer
	//=====added for arb-trees=====
	bool insert_bitmap(int _tm, int _rid, float *_rmbr, unsigned char *_bitchar);
	void agg_qry(bool *_qbitmaps, float *_qmbr, float *_qt, float _ed);
	bool get_reg_bitchars(int _rid, float *_rmbr, int _tm, unsigned char *_bitchars);
	void load_heap(bool *_qbitmaps, float *_qmbr, float *_qt, float _ed);
};

#endif